package extensionUpdate.views;

import java.util.ArrayList;
import org.eclipse.core.internal.runtime.InternalPlatform;
import org.eclipse.core.runtime.IExtension;
import org.eclipse.core.runtime.IExtensionPoint;
import org.eclipse.core.runtime.IPluginDescriptor;
import org.eclipse.core.runtime.IPluginRegistry;
import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

public class ExtensionUpdateContentProvider implements ITreeContentProvider {

	/**
	 * Constructor for ExtensionUpdateContentProvider .
	 */
	public ExtensionUpdateContentProvider () {
	}

	public void dispose() {
	}
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
	}

	/**
	 * @see ITreeContentProvider#getChildren(Object)
	 */
	public Object[] getChildren(Object parentElement) {
		
		if (parentElement instanceof IPluginDescriptor) {
			ArrayList list = new ArrayList();
			IExtensionPoint[] extensionpoints = ((IPluginDescriptor)parentElement).getExtensionPoints();
			if (extensionpoints.length > 0)
				list.add(extensionpoints);
			IExtension[] extensions = ((IPluginDescriptor)parentElement).getExtensions();
			if (extensions.length > 0)
				list.add(extensions);
			return list.toArray();
		}
		
		if (parentElement instanceof IExtensionPoint[]) 
			return (IExtensionPoint[])parentElement;
		
		if (parentElement instanceof IExtension[]) 
			return (IExtension[])parentElement;
		
		return new Object[0];
	}

	/**
	 * @see ITreeContentProvider#getParent(Object)
	 */
	public Object getParent(Object element) {
		if (element instanceof IPluginDescriptor) 
			return InternalPlatform.getPluginRegistry();
	
		if (element instanceof IExtensionPoint[])
			return ((IExtensionPoint[])element)[0].getDeclaringPluginDescriptor();
		
		if (element instanceof IExtension[]) 
			return ((IExtension[])element)[0].getDeclaringPluginDescriptor();
		
		if (element instanceof IExtensionPoint)
			return ((IExtensionPoint)element).getDeclaringPluginDescriptor();
		
		if (element instanceof IExtension)
			return ((IExtension)element).getDeclaringPluginDescriptor();
		
		return null;
		
	}

	/**
	 * @see ITreeContentProvider#hasChildren(Object)
	 */
	public boolean hasChildren(Object element) {
		
		if (element instanceof IPluginDescriptor) {
			ArrayList list = new ArrayList();
			list.add(((IPluginDescriptor)element).getExtensionPoints());
			list.add(((IPluginDescriptor)element).getExtensions());
			return (list.toArray().length>0)?true:false;
		}
		
		if (element instanceof IExtensionPoint[] ||
			element instanceof IExtension[])
			return true;

		return false;
	}

	/**
	 * @see IStructuredContentProvider#getElements(Object)
	 */
	public Object[] getElements(Object inputElement) {
		  if (inputElement instanceof IPluginRegistry)
			  return ((IPluginRegistry)inputElement).getPluginDescriptors();
	
		  return new Object[0];	
	}

}