package extensionUpdate.views;

import org.eclipse.core.internal.runtime.InternalPlatform;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.jface.viewers.ViewerSorter;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.TreeItem;
import org.eclipse.ui.part.ViewPart;

/**
 * Insert the type's description here.
 * @see ViewPart
 */

public class ExtensionUpdateView extends ViewPart implements SelectionListener {

	TreeViewer viewer;
	private ExtensionUpdateViewMenu menu;
	
	class NameSorter extends ViewerSorter {
	}

	/**
	 * The Constructor for ExtensionUpdateView class
	 */
	public ExtensionUpdateView() {
		super();
	}
	/* (non-Javadoc)
	 * Method declared on IWorkbenchPart
	 */
	public void createPartControl(Composite parent) {

		viewer =
			new TreeViewer(parent, SWT.MULTI | SWT.H_SCROLL | SWT.V_SCROLL);
		viewer.setContentProvider(new ExtensionUpdateContentProvider());
		viewer.setLabelProvider(new ExtensionUpdateLabelProvider());
		viewer.setSorter(new NameSorter());
		viewer.setInput(InternalPlatform.getPluginRegistry());
		viewer.getTree().addSelectionListener(this);
		getViewSite().setSelectionProvider(viewer);
		menu = new ExtensionUpdateViewMenu((Composite)viewer.getControl());
	}

	public void dispose() {
	}

	public void widgetSelected(SelectionEvent e) {
		
		if (!(e.item instanceof TreeItem))
			return;
			
		menu.enableMenuItems(e.item.getData());
	}

	public void widgetDefaultSelected(SelectionEvent e) {
	}

	/* (non-Javadoc)
	 * Method declared on IWorkbenchPart
	 */
	public void setFocus() {
		if (viewer != null && viewer.getControl() != null)
			viewer.getControl().setFocus();
	}


}
