package extensionUpdate.views;

import extensionUpdate.ExtensionUpdatePlugin;

import org.eclipse.core.internal.runtime.InternalPlatform;
import org.eclipse.core.runtime.model.ExtensionModel;
import org.eclipse.core.runtime.IExtension;
import org.eclipse.core.runtime.IExtensionPoint;
import org.eclipse.core.runtime.IPluginDescriptor;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.SWT;
import org.eclipse.ui.extensionevents.ExtensionEventDispatcher;


public class ExtensionUpdateViewMenu implements SelectionListener {
	private Object object;
	private Menu menu;

	public static final String ACTIVATE 	= "ExtensionUpdateViewMenu.activate.text";
	public static final String DEACTIVATE 	= "ExtensionUpdateViewMenu.deactivate.text";
	public static final String LOAD_NEW 	= "ExtensionUpdateViewMenu.loadNew.text";
	public static final String UNLOAD 		= "ExtensionUpdateViewMenu.unload.text";

/**
 * Creates a new ViewMenu
 */
public ExtensionUpdateViewMenu (Composite parent) {
		menu = new Menu(parent);
		MenuItem item = new MenuItem(menu, SWT.NONE);
		item.setText(ExtensionUpdatePlugin.getResourceString(ACTIVATE));
		item.addSelectionListener(this);
		item = new MenuItem(menu, SWT.NONE);
		item.setText(ExtensionUpdatePlugin.getResourceString(DEACTIVATE));
		item.addSelectionListener(this);
		item = new MenuItem(menu, SWT.NONE);
		item.setText(ExtensionUpdatePlugin.getResourceString(LOAD_NEW));
		item.addSelectionListener(this);
		item = new MenuItem(menu, SWT.NONE);
		item.setText(ExtensionUpdatePlugin.getResourceString(UNLOAD));
		item.addSelectionListener(this);
		parent.setMenu(menu);
}

public void enableMenuItems(Object object) {
	this.object = object;
	// all are enabled for now
/*
	MenuItem[] items = menu.getItems();
	for(int i = 0; i < items.length; i++)
		if (items[i].getText().equals(ExtensionUpdatePlugin.getResourceString(UNLOAD)))
			items[i].setEnabled(true);
		else
			items[i].setEnabled(false);
*/				
}

public void widgetSelected(SelectionEvent e) {

	if (!(e.widget instanceof MenuItem))
		return;

	String action = ((MenuItem) e.widget).getText();
	if (object instanceof IExtension) {
		selectExtensionAction(action); 
		return;
	}
	if (object instanceof IPluginDescriptor) {
		selectPluginAction(action);
		return;
	}
}

public void widgetDefaultSelected(SelectionEvent e) {
}

private void selectExtensionAction(String action) {
	if (action.equals(ExtensionUpdatePlugin.getResourceString(UNLOAD))) {
		processUnload();
		return;
	}
	if (action.equals(ExtensionUpdatePlugin.getResourceString(LOAD_NEW))) {
		processLoad();
		return;
	}
}

private void selectPluginAction(String action) {
}

private void processUnload() {
	IExtension ext = (IExtension) object;
	String extPtId = ((ExtensionModel)ext).getExtensionPoint();
	IExtensionPoint extPt = InternalPlatform.getPluginRegistry().getExtensionPoint(extPtId);
	ExtensionEventDispatcher.fireExtensionRevokeEvent(extPt, ext);
}

private void processLoad() {
	IExtension ext = (IExtension) object;
	String extPtId = ((ExtensionModel)ext).getExtensionPoint();
	IExtensionPoint extPt = InternalPlatform.getPluginRegistry().getExtensionPoint(extPtId);
	ExtensionEventDispatcher.fireExtensionAppearEvent(extPt, ext);
}
}